var NSLibrary = NSLibrary || {};
NSLibrary.Client = NSLibrary.Client || {};
NSLibrary.Client.Chat = NSLibrary.Client.Chat || {};

(function(chat) {

    chat.target=false;
    chat.isChatting =0;
    chat.lastTab = false;
    chat.chatTab = false;
    chat.chatID = -1;
    chat.cachedMessages = [];
    chat.title = '';
    chat.members = [];

    chat.startChat = function(){
        //open window
        chat.members = [];
        chat.cachedMessages = [];
        chat.target = false;
        chrome.tabs.query({ currentWindow: true, active: true }, function (t) {
                chat.lastTab = t[0].id;

                chrome.tabs.create({url: 'chat.html'}, function(tab) {
                    chat.chatTab = tab.id;
                    chat.isChatting = 1;
                    chat.chatTimer = window.setInterval(function(){

                        chrome.tabs.get(chat.chatTab , function (t) {
                                if (t===undefined){
                                    chat.endChat();
                                }
                        });
                    },1000);
                });


 
        });

    };
    chat.sendChatCommand = function(cmd, text) {
        var chatMsg = String.fromCharCode(130, 0) +  chat.chatID + String.fromCharCode(cmd, 0, 0, 0) + localStorage.clientName;
        while (chatMsg.length < 26)
            chatMsg += z;
        chatMsg += text + z;
        senddata(chat.chatCID, chatMsg);
    };

    chat.endChat = function(){
        chat.sendChatCommand(3, "");
        chat.title = "";
        chat.isChatting=0;
        chat.chatTab = false;
    };

    chat.sendChatJoin = function() {
        chat.sendChatCommand(2, "");
    };

    chat.addMessage = function(from, message){
        if (message!==""){
            var span = document.createElement("div");
            span.innerHTML = "<b>" +  from + ' ' + NSLibrary.Translate('SAYS') + ": </b><br/>&nbsp;&nbsp;&nbsp;" + message;
            if (chat.target){
                chat.target.appendChild(span);
                chat.target.scrollTop = 99999999;
            }else{
                chat.cachedMessages.push(span);
            }
        }
    };
     chat.addJoinedMessage = function(from){
        if (chat.members.indexOf(from)<0){
            var span = document.createElement("div");
            span.innerHTML = "<b>" + NSLibrary.Translate('PLACEHOLDER_HAS_JOINED', from) + "</b>";
            span.style.color="darkgreen";
            if (chat.target){
                chat.target.appendChild(span);
                chat.target.scrollTop = 99999999;
            }else{
                chat.cachedMessages.push(span);
            }
            chat.members.push(from);
        }
    };
    chat.sendMessage = function(message){
        if (message.length > 0){
            chat.sendChatCommand(4, message);
            chat.addMessage(localStorage.clientName, message);
        }
    };
    chat.setTarget = function(element){
        chat.target = element;
        //check if we have any cached messages
        var length = chat.cachedMessages.length;
        for (var i=0;i<length;i++){
            chat.target.appendChild(chat.cachedMessages[0]);
            chat.cachedMessages.splice(0, 1);
        }
        element.previousElementSibling.innerHTML = chat.title;
        chat.target.scrollTop = 99999999;
    };
    chat.eject = function(){
        //close window
        window.clearInterval(chat.chatTimer);
        if (chat.chatTab){
            chrome.tabs.remove(chat.chatTab);
        }
    };
    chat.setTitle = function(title){
        if (!title || title===""){
            chat.title = "";
        }else{
            chat.title = NSLibrary.Translate('TOPIC') +": " + title;
        }
    };

})(NSLibrary.Client.Chat);
